//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
// Copyright 2003, 2004, 2005, 2006, 2007, 2008, 2009 James Lehman.
// This source is distributed under the terms of the GNU General Public License.
//
// LaserBoy_header.cpp is part of LaserBoy.
//
// LaserBoy is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// LaserBoy is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with LaserBoy. If not, see <http://www.gnu.org/licenses/>.
//
//############################################################################
#include "LaserBoy_header.hpp"

//############################################################################
int LaserBoy_header::from_ifstream_ild(ifstream&  in)
{
    int         i;
    char        a, b;
    //------------------------------------------------------------------------
    name.erase    ();
    owner.erase   ();
    //------------------------------------------------------------------------
    if(!in.eof())
    {
        in.get(a); if(a != 'I') return LASERBOY_BAD_HEADER;
        in.get(a); if(a != 'L') return LASERBOY_BAD_HEADER;
        in.get(a); if(a != 'D') return LASERBOY_BAD_HEADER;
        in.get(a); if(a != 'A') return LASERBOY_BAD_HEADER;
        in.get(a); if(a !=  0 ) return LASERBOY_BAD_HEADER;
        in.get(a); if(a !=  0 ) return LASERBOY_BAD_HEADER;
        in.get(a); if(a !=  0 ) return LASERBOY_BAD_HEADER;

        in.get(format);

        for(i = 0; i < 8; i++)
        {
            in.get(a);
            name += a;
        }

        for(i = 0; i < 8; i++)
        {
            in.get(a);
            owner += a;
        }

        in.get(a);    in.get(b);
        quantity = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(a);    in.get(b);
        identity = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(a);    in.get(b);
        total    = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(scanner);
        in.get(future) ;
    }
    //------------------------------------------------------------------------
    return in.bad();
}

//############################################################################
void LaserBoy_header::to_ofstream_ild(ofstream& out, bool dumb_file_format)
{
    int i;
    //------------------------------------------------------------------------
    out.put('I');
    out.put('L');
    out.put('D');
    out.put('A');
    out.put( 0 );
    out.put( 0 );
    out.put( 0 );
    //------------------------------------------------------------------------
    if(dumb_file_format)
    {
        if(format == LASERBOY_3D_FRAME)
            format = LASERBOY_3D_FRAME_RGB;
        else if(format == LASERBOY_2D_FRAME)
            format = LASERBOY_2D_FRAME_RGB;
    }
    out.put(format);
    //------------------------------------------------------------------------
    for(i = 0; i < 8; i++)
        out.put(name[i]);

    for(i = 0; i < 8; i++)
        out.put(owner[i]);

    out.put((char)((quantity & 0xff00) >> 8));
    out.put((char) (quantity & 0x00ff)      );

    out.put((char)((identity & 0xff00) >> 8));
    out.put((char) (identity & 0x00ff)      );

    out.put((char)((total    & 0xff00) >> 8));
    out.put((char) (total    & 0x00ff)      );

    out.put(scanner);
    out.put(future) ;
    //------------------------------------------------------------------------
    return;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
